From 8e61092dcc0e3dd733d8632f6fd83eb75c332c87 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Fri, 26 Jan 2024 17:16:27 +0800
Subject: [PATCH] Build:IGKBoard-All:Add SDK download from server support

---
 yocto/build.sh |   47 ++++++++++++++++++++++++++++++++++-------------
 1 files changed, 34 insertions(+), 13 deletions(-)

diff --git a/yocto/build.sh b/yocto/build.sh
index 1cff93e..5bd6c3d 100755
--- a/yocto/build.sh
+++ b/yocto/build.sh
@@ -25,7 +25,7 @@
 CONF_FILE=$TOP_PATH/config.json
 
 # Download path
-DL_PATH="/srv/yocto_packets/"
+#DL_PATH="/srv/yocto_packets/"
 
 # shell script will exit once get command error
 set -e
@@ -97,31 +97,52 @@
     export BOARD=`jq -r ".bsp.board" $CONF_FILE | tr 'A-Z' 'a-z'`
     export BSP_VER=`jq -r ".bsp.version" $CONF_FILE | tr 'A-Z' 'a-z'`
     export YCT_VER=`jq -r ".system.version" $CONF_FILE | tr 'A-Z' 'a-z'`
+    export BSP_URL=`jq -r ".bsp.giturl" $CONF_FILE`
 
     export YCT_BOARD=`echo $BOARD| cut -d- -f1`
     export YCT_META=meta-$YCT_BOARD
-    export YCT_PATH=$PRJ_PATH/$YCT_VER-$BSP_VER
+    export YCT_SRC=$YCT_VER-$BSP_VER
+    export YCT_PATH=$PRJ_PATH/$YCT_SRC
     export BUILD_DIR=${BOARD}
 }
 
 function do_fetch()
 {
+    cd $PRJ_PATH
 
-    mkdir -p $YCT_PATH && cd $YCT_PATH
+    if [ ! -d $YCT_SRC/sources ] ; then
 
-    if [ ! -d sources ] ; then
+        if [[ $BSP_URL =~ github.com ]] ; then
 
-        pr_info "start repo fetch Yocto $YCT_VER source code"
+            pr_info "start repo fetch Yocto $YCT_VER source code"
 
-        if ! command -v repo > /dev/null 2>&1 ; then
-            curl https://storage.googleapis.com/git-repo-downloads/repo > repo
-            chmod a+x repo
-            export PATH=$YCT_PATH:$PATH
+            mkdir -p $YCT_PATH && cd $YCT_PATH
+
+            if ! command -v repo > /dev/null 2>&1 ; then
+                curl https://storage.googleapis.com/git-repo-downloads/repo > repo
+                chmod a+x repo
+                export PATH=$YCT_PATH:$PATH
+            fi
+
+            BSP_VER=`echo $BSP_VER | sed 's/lf/imx/'`
+            repo init -u https://github.com/nxp-imx/imx-manifest -b imx-linux-$YCT_VER -m $BSP_VER.xml
+            repo sync && rm -f repo
+
+        else
+
+            pr_info "start download fetch Yocto $YCT_VER source code"
+
+            mkdir -p $TARBALL_PATH
+
+            # Download source code packet
+            if [ ! -s $TARBALL_PATH/$YCT_SRC.tar.xz ] ; then
+                wget $BSP_URL/bsp/$BSP_VER/$YCT_SRC.tar.xz -P $TARBALL_PATH
+            fi
+
+            # decompress source code packet
+            do_unpack $TARBALL_PATH/$YCT_SRC.tar.xz
+
         fi
-
-        BSP_VER=`echo $BSP_VER | sed 's/lf/imx/'`
-        repo init -u https://github.com/nxp-imx/imx-manifest -b imx-linux-$YCT_VER -m $BSP_VER.xml
-        repo sync && rm -f repo
 
     else
         pr_warn "Yocto $YCT_VER source code fetched already"

--
Gitblit v1.9.1